// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: attribute_config.proto

#ifndef PROTOBUF_attribute_5fconfig_2eproto__INCLUDED
#define PROTOBUF_attribute_5fconfig_2eproto__INCLUDED

#include <string>

#include <google/protobuf/stubs/common.h>

#if GOOGLE_PROTOBUF_VERSION < 3005000
#error This file was generated by a newer version of protoc which is
#error incompatible with your Protocol Buffer headers.  Please update
#error your headers.
#endif
#if 3005000 < GOOGLE_PROTOBUF_MIN_PROTOC_VERSION
#error This file was generated by an older version of protoc which is
#error incompatible with your Protocol Buffer headers.  Please
#error regenerate this file with a newer version of protoc.
#endif

#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/arena.h>
#include <google/protobuf/arenastring.h>
#include <google/protobuf/generated_message_table_driven.h>
#include <google/protobuf/generated_message_util.h>
#include <google/protobuf/metadata.h>
#include <google/protobuf/message.h>
#include <google/protobuf/repeated_field.h>  // IWYU pragma: export
#include <google/protobuf/extension_set.h>  // IWYU pragma: export
#include <google/protobuf/unknown_field_set.h>
#include "tango_enums.pb.h"
#include "error.pb.h"
// @@protoc_insertion_point(includes)

namespace protobuf_attribute_5fconfig_2eproto {
// Internal implementation detail -- do not use these members.
struct TableStruct {
  static const ::google::protobuf::internal::ParseTableField entries[];
  static const ::google::protobuf::internal::AuxillaryParseTableField aux[];
  static const ::google::protobuf::internal::ParseTable schema[4];
  static const ::google::protobuf::internal::FieldMetadata field_metadata[];
  static const ::google::protobuf::internal::SerializationTable serialization_table[];
  static const ::google::protobuf::uint32 offsets[];
};
void AddDescriptors();
void InitDefaultsAttributeConfigImpl();
void InitDefaultsAttributeConfig();
void InitDefaultsAttributeConfigReplyImpl();
void InitDefaultsAttributeConfigReply();
void InitDefaultsEventPropertiesImpl();
void InitDefaultsEventProperties();
void InitDefaultsAttributeAlarmImpl();
void InitDefaultsAttributeAlarm();
inline void InitDefaults() {
  InitDefaultsAttributeConfig();
  InitDefaultsAttributeConfigReply();
  InitDefaultsEventProperties();
  InitDefaultsAttributeAlarm();
}
}  // namespace protobuf_attribute_5fconfig_2eproto
namespace mascot {
class AttributeAlarm;
class AttributeAlarmDefaultTypeInternal;
extern AttributeAlarmDefaultTypeInternal _AttributeAlarm_default_instance_;
class AttributeConfig;
class AttributeConfigDefaultTypeInternal;
extern AttributeConfigDefaultTypeInternal _AttributeConfig_default_instance_;
class AttributeConfigReply;
class AttributeConfigReplyDefaultTypeInternal;
extern AttributeConfigReplyDefaultTypeInternal _AttributeConfigReply_default_instance_;
class EventProperties;
class EventPropertiesDefaultTypeInternal;
extern EventPropertiesDefaultTypeInternal _EventProperties_default_instance_;
}  // namespace mascot
namespace mascot {

// ===================================================================

class AttributeConfig : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.AttributeConfig) */ {
 public:
  AttributeConfig();
  virtual ~AttributeConfig();

  AttributeConfig(const AttributeConfig& from);

  inline AttributeConfig& operator=(const AttributeConfig& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  AttributeConfig(AttributeConfig&& from) noexcept
    : AttributeConfig() {
    *this = ::std::move(from);
  }

  inline AttributeConfig& operator=(AttributeConfig&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const AttributeConfig& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const AttributeConfig* internal_default_instance() {
    return reinterpret_cast<const AttributeConfig*>(
               &_AttributeConfig_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    0;

  void Swap(AttributeConfig* other);
  friend void swap(AttributeConfig& a, AttributeConfig& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline AttributeConfig* New() const PROTOBUF_FINAL { return New(NULL); }

  AttributeConfig* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const AttributeConfig& from);
  void MergeFrom(const AttributeConfig& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(AttributeConfig* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // repeated string enum_labels = 20;
  int enum_labels_size() const;
  void clear_enum_labels();
  static const int kEnumLabelsFieldNumber = 20;
  const ::std::string& enum_labels(int index) const;
  ::std::string* mutable_enum_labels(int index);
  void set_enum_labels(int index, const ::std::string& value);
  #if LANG_CXX11
  void set_enum_labels(int index, ::std::string&& value);
  #endif
  void set_enum_labels(int index, const char* value);
  void set_enum_labels(int index, const char* value, size_t size);
  ::std::string* add_enum_labels();
  void add_enum_labels(const ::std::string& value);
  #if LANG_CXX11
  void add_enum_labels(::std::string&& value);
  #endif
  void add_enum_labels(const char* value);
  void add_enum_labels(const char* value, size_t size);
  const ::google::protobuf::RepeatedPtrField< ::std::string>& enum_labels() const;
  ::google::protobuf::RepeatedPtrField< ::std::string>* mutable_enum_labels();

  // repeated string extensions = 23;
  int extensions_size() const;
  void clear_extensions();
  static const int kExtensionsFieldNumber = 23;
  const ::std::string& extensions(int index) const;
  ::std::string* mutable_extensions(int index);
  void set_extensions(int index, const ::std::string& value);
  #if LANG_CXX11
  void set_extensions(int index, ::std::string&& value);
  #endif
  void set_extensions(int index, const char* value);
  void set_extensions(int index, const char* value, size_t size);
  ::std::string* add_extensions();
  void add_extensions(const ::std::string& value);
  #if LANG_CXX11
  void add_extensions(::std::string&& value);
  #endif
  void add_extensions(const char* value);
  void add_extensions(const char* value, size_t size);
  const ::google::protobuf::RepeatedPtrField< ::std::string>& extensions() const;
  ::google::protobuf::RepeatedPtrField< ::std::string>* mutable_extensions();

  // repeated string sys_extensions = 24;
  int sys_extensions_size() const;
  void clear_sys_extensions();
  static const int kSysExtensionsFieldNumber = 24;
  const ::std::string& sys_extensions(int index) const;
  ::std::string* mutable_sys_extensions(int index);
  void set_sys_extensions(int index, const ::std::string& value);
  #if LANG_CXX11
  void set_sys_extensions(int index, ::std::string&& value);
  #endif
  void set_sys_extensions(int index, const char* value);
  void set_sys_extensions(int index, const char* value, size_t size);
  ::std::string* add_sys_extensions();
  void add_sys_extensions(const ::std::string& value);
  #if LANG_CXX11
  void add_sys_extensions(::std::string&& value);
  #endif
  void add_sys_extensions(const char* value);
  void add_sys_extensions(const char* value, size_t size);
  const ::google::protobuf::RepeatedPtrField< ::std::string>& sys_extensions() const;
  ::google::protobuf::RepeatedPtrField< ::std::string>* mutable_sys_extensions();

  // string name = 1;
  void clear_name();
  static const int kNameFieldNumber = 1;
  const ::std::string& name() const;
  void set_name(const ::std::string& value);
  #if LANG_CXX11
  void set_name(::std::string&& value);
  #endif
  void set_name(const char* value);
  void set_name(const char* value, size_t size);
  ::std::string* mutable_name();
  ::std::string* release_name();
  void set_allocated_name(::std::string* name);

  // string description = 9;
  void clear_description();
  static const int kDescriptionFieldNumber = 9;
  const ::std::string& description() const;
  void set_description(const ::std::string& value);
  #if LANG_CXX11
  void set_description(::std::string&& value);
  #endif
  void set_description(const char* value);
  void set_description(const char* value, size_t size);
  ::std::string* mutable_description();
  ::std::string* release_description();
  void set_allocated_description(::std::string* description);

  // string label = 10;
  void clear_label();
  static const int kLabelFieldNumber = 10;
  const ::std::string& label() const;
  void set_label(const ::std::string& value);
  #if LANG_CXX11
  void set_label(::std::string&& value);
  #endif
  void set_label(const char* value);
  void set_label(const char* value, size_t size);
  ::std::string* mutable_label();
  ::std::string* release_label();
  void set_allocated_label(::std::string* label);

  // string unit = 11;
  void clear_unit();
  static const int kUnitFieldNumber = 11;
  const ::std::string& unit() const;
  void set_unit(const ::std::string& value);
  #if LANG_CXX11
  void set_unit(::std::string&& value);
  #endif
  void set_unit(const char* value);
  void set_unit(const char* value, size_t size);
  ::std::string* mutable_unit();
  ::std::string* release_unit();
  void set_allocated_unit(::std::string* unit);

  // string standard_unit = 12;
  void clear_standard_unit();
  static const int kStandardUnitFieldNumber = 12;
  const ::std::string& standard_unit() const;
  void set_standard_unit(const ::std::string& value);
  #if LANG_CXX11
  void set_standard_unit(::std::string&& value);
  #endif
  void set_standard_unit(const char* value);
  void set_standard_unit(const char* value, size_t size);
  ::std::string* mutable_standard_unit();
  ::std::string* release_standard_unit();
  void set_allocated_standard_unit(::std::string* standard_unit);

  // string display_unit = 13;
  void clear_display_unit();
  static const int kDisplayUnitFieldNumber = 13;
  const ::std::string& display_unit() const;
  void set_display_unit(const ::std::string& value);
  #if LANG_CXX11
  void set_display_unit(::std::string&& value);
  #endif
  void set_display_unit(const char* value);
  void set_display_unit(const char* value, size_t size);
  ::std::string* mutable_display_unit();
  ::std::string* release_display_unit();
  void set_allocated_display_unit(::std::string* display_unit);

  // string format = 14;
  void clear_format();
  static const int kFormatFieldNumber = 14;
  const ::std::string& format() const;
  void set_format(const ::std::string& value);
  #if LANG_CXX11
  void set_format(::std::string&& value);
  #endif
  void set_format(const char* value);
  void set_format(const char* value, size_t size);
  ::std::string* mutable_format();
  ::std::string* release_format();
  void set_allocated_format(::std::string* format);

  // string min_value = 15;
  void clear_min_value();
  static const int kMinValueFieldNumber = 15;
  const ::std::string& min_value() const;
  void set_min_value(const ::std::string& value);
  #if LANG_CXX11
  void set_min_value(::std::string&& value);
  #endif
  void set_min_value(const char* value);
  void set_min_value(const char* value, size_t size);
  ::std::string* mutable_min_value();
  ::std::string* release_min_value();
  void set_allocated_min_value(::std::string* min_value);

  // string max_value = 16;
  void clear_max_value();
  static const int kMaxValueFieldNumber = 16;
  const ::std::string& max_value() const;
  void set_max_value(const ::std::string& value);
  #if LANG_CXX11
  void set_max_value(::std::string&& value);
  #endif
  void set_max_value(const char* value);
  void set_max_value(const char* value, size_t size);
  ::std::string* mutable_max_value();
  ::std::string* release_max_value();
  void set_allocated_max_value(::std::string* max_value);

  // string writable_attr_name = 17;
  void clear_writable_attr_name();
  static const int kWritableAttrNameFieldNumber = 17;
  const ::std::string& writable_attr_name() const;
  void set_writable_attr_name(const ::std::string& value);
  #if LANG_CXX11
  void set_writable_attr_name(::std::string&& value);
  #endif
  void set_writable_attr_name(const char* value);
  void set_writable_attr_name(const char* value, size_t size);
  ::std::string* mutable_writable_attr_name();
  ::std::string* release_writable_attr_name();
  void set_allocated_writable_attr_name(::std::string* writable_attr_name);

  // string root_attr_name = 19;
  void clear_root_attr_name();
  static const int kRootAttrNameFieldNumber = 19;
  const ::std::string& root_attr_name() const;
  void set_root_attr_name(const ::std::string& value);
  #if LANG_CXX11
  void set_root_attr_name(::std::string&& value);
  #endif
  void set_root_attr_name(const char* value);
  void set_root_attr_name(const char* value, size_t size);
  ::std::string* mutable_root_attr_name();
  ::std::string* release_root_attr_name();
  void set_allocated_root_attr_name(::std::string* root_attr_name);

  // .mascot.AttributeAlarm att_alarm = 21;
  bool has_att_alarm() const;
  void clear_att_alarm();
  static const int kAttAlarmFieldNumber = 21;
  const ::mascot::AttributeAlarm& att_alarm() const;
  ::mascot::AttributeAlarm* release_att_alarm();
  ::mascot::AttributeAlarm* mutable_att_alarm();
  void set_allocated_att_alarm(::mascot::AttributeAlarm* att_alarm);

  // .mascot.EventProperties event_prop = 22;
  bool has_event_prop() const;
  void clear_event_prop();
  static const int kEventPropFieldNumber = 22;
  const ::mascot::EventProperties& event_prop() const;
  ::mascot::EventProperties* release_event_prop();
  ::mascot::EventProperties* mutable_event_prop();
  void set_allocated_event_prop(::mascot::EventProperties* event_prop);

  // .mascot.AttrWriteType writable = 2;
  void clear_writable();
  static const int kWritableFieldNumber = 2;
  ::mascot::AttrWriteType writable() const;
  void set_writable(::mascot::AttrWriteType value);

  // .mascot.AttrDataFormat data_format = 3;
  void clear_data_format();
  static const int kDataFormatFieldNumber = 3;
  ::mascot::AttrDataFormat data_format() const;
  void set_data_format(::mascot::AttrDataFormat value);

  // int64 data_type = 4;
  void clear_data_type();
  static const int kDataTypeFieldNumber = 4;
  ::google::protobuf::int64 data_type() const;
  void set_data_type(::google::protobuf::int64 value);

  // int64 max_dim_x = 7;
  void clear_max_dim_x();
  static const int kMaxDimXFieldNumber = 7;
  ::google::protobuf::int64 max_dim_x() const;
  void set_max_dim_x(::google::protobuf::int64 value);

  // int64 max_dim_y = 8;
  void clear_max_dim_y();
  static const int kMaxDimYFieldNumber = 8;
  ::google::protobuf::int64 max_dim_y() const;
  void set_max_dim_y(::google::protobuf::int64 value);

  // bool memorized = 5;
  void clear_memorized();
  static const int kMemorizedFieldNumber = 5;
  bool memorized() const;
  void set_memorized(bool value);

  // bool mem_init = 6;
  void clear_mem_init();
  static const int kMemInitFieldNumber = 6;
  bool mem_init() const;
  void set_mem_init(bool value);

  // .mascot.DispLevel level = 18;
  void clear_level();
  static const int kLevelFieldNumber = 18;
  ::mascot::DispLevel level() const;
  void set_level(::mascot::DispLevel value);

  // @@protoc_insertion_point(class_scope:mascot.AttributeConfig)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::google::protobuf::RepeatedPtrField< ::std::string> enum_labels_;
  ::google::protobuf::RepeatedPtrField< ::std::string> extensions_;
  ::google::protobuf::RepeatedPtrField< ::std::string> sys_extensions_;
  ::google::protobuf::internal::ArenaStringPtr name_;
  ::google::protobuf::internal::ArenaStringPtr description_;
  ::google::protobuf::internal::ArenaStringPtr label_;
  ::google::protobuf::internal::ArenaStringPtr unit_;
  ::google::protobuf::internal::ArenaStringPtr standard_unit_;
  ::google::protobuf::internal::ArenaStringPtr display_unit_;
  ::google::protobuf::internal::ArenaStringPtr format_;
  ::google::protobuf::internal::ArenaStringPtr min_value_;
  ::google::protobuf::internal::ArenaStringPtr max_value_;
  ::google::protobuf::internal::ArenaStringPtr writable_attr_name_;
  ::google::protobuf::internal::ArenaStringPtr root_attr_name_;
  ::mascot::AttributeAlarm* att_alarm_;
  ::mascot::EventProperties* event_prop_;
  int writable_;
  int data_format_;
  ::google::protobuf::int64 data_type_;
  ::google::protobuf::int64 max_dim_x_;
  ::google::protobuf::int64 max_dim_y_;
  bool memorized_;
  bool mem_init_;
  int level_;
  mutable int _cached_size_;
  friend struct ::protobuf_attribute_5fconfig_2eproto::TableStruct;
  friend void ::protobuf_attribute_5fconfig_2eproto::InitDefaultsAttributeConfigImpl();
};
// -------------------------------------------------------------------

class AttributeConfigReply : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.AttributeConfigReply) */ {
 public:
  AttributeConfigReply();
  virtual ~AttributeConfigReply();

  AttributeConfigReply(const AttributeConfigReply& from);

  inline AttributeConfigReply& operator=(const AttributeConfigReply& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  AttributeConfigReply(AttributeConfigReply&& from) noexcept
    : AttributeConfigReply() {
    *this = ::std::move(from);
  }

  inline AttributeConfigReply& operator=(AttributeConfigReply&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const AttributeConfigReply& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const AttributeConfigReply* internal_default_instance() {
    return reinterpret_cast<const AttributeConfigReply*>(
               &_AttributeConfigReply_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    1;

  void Swap(AttributeConfigReply* other);
  friend void swap(AttributeConfigReply& a, AttributeConfigReply& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline AttributeConfigReply* New() const PROTOBUF_FINAL { return New(NULL); }

  AttributeConfigReply* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const AttributeConfigReply& from);
  void MergeFrom(const AttributeConfigReply& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(AttributeConfigReply* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // .mascot.Error error = 2;
  bool has_error() const;
  void clear_error();
  static const int kErrorFieldNumber = 2;
  const ::mascot::Error& error() const;
  ::mascot::Error* release_error();
  ::mascot::Error* mutable_error();
  void set_allocated_error(::mascot::Error* error);

  // .mascot.AttributeConfig data = 3;
  bool has_data() const;
  void clear_data();
  static const int kDataFieldNumber = 3;
  const ::mascot::AttributeConfig& data() const;
  ::mascot::AttributeConfig* release_data();
  ::mascot::AttributeConfig* mutable_data();
  void set_allocated_data(::mascot::AttributeConfig* data);

  // bool success = 1;
  void clear_success();
  static const int kSuccessFieldNumber = 1;
  bool success() const;
  void set_success(bool value);

  // @@protoc_insertion_point(class_scope:mascot.AttributeConfigReply)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::mascot::Error* error_;
  ::mascot::AttributeConfig* data_;
  bool success_;
  mutable int _cached_size_;
  friend struct ::protobuf_attribute_5fconfig_2eproto::TableStruct;
  friend void ::protobuf_attribute_5fconfig_2eproto::InitDefaultsAttributeConfigReplyImpl();
};
// -------------------------------------------------------------------

class EventProperties : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.EventProperties) */ {
 public:
  EventProperties();
  virtual ~EventProperties();

  EventProperties(const EventProperties& from);

  inline EventProperties& operator=(const EventProperties& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  EventProperties(EventProperties&& from) noexcept
    : EventProperties() {
    *this = ::std::move(from);
  }

  inline EventProperties& operator=(EventProperties&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const EventProperties& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const EventProperties* internal_default_instance() {
    return reinterpret_cast<const EventProperties*>(
               &_EventProperties_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    2;

  void Swap(EventProperties* other);
  friend void swap(EventProperties& a, EventProperties& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline EventProperties* New() const PROTOBUF_FINAL { return New(NULL); }

  EventProperties* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const EventProperties& from);
  void MergeFrom(const EventProperties& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(EventProperties* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // string empty = 1;
  void clear_empty();
  static const int kEmptyFieldNumber = 1;
  const ::std::string& empty() const;
  void set_empty(const ::std::string& value);
  #if LANG_CXX11
  void set_empty(::std::string&& value);
  #endif
  void set_empty(const char* value);
  void set_empty(const char* value, size_t size);
  ::std::string* mutable_empty();
  ::std::string* release_empty();
  void set_allocated_empty(::std::string* empty);

  // @@protoc_insertion_point(class_scope:mascot.EventProperties)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::google::protobuf::internal::ArenaStringPtr empty_;
  mutable int _cached_size_;
  friend struct ::protobuf_attribute_5fconfig_2eproto::TableStruct;
  friend void ::protobuf_attribute_5fconfig_2eproto::InitDefaultsEventPropertiesImpl();
};
// -------------------------------------------------------------------

class AttributeAlarm : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.AttributeAlarm) */ {
 public:
  AttributeAlarm();
  virtual ~AttributeAlarm();

  AttributeAlarm(const AttributeAlarm& from);

  inline AttributeAlarm& operator=(const AttributeAlarm& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  AttributeAlarm(AttributeAlarm&& from) noexcept
    : AttributeAlarm() {
    *this = ::std::move(from);
  }

  inline AttributeAlarm& operator=(AttributeAlarm&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const AttributeAlarm& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const AttributeAlarm* internal_default_instance() {
    return reinterpret_cast<const AttributeAlarm*>(
               &_AttributeAlarm_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    3;

  void Swap(AttributeAlarm* other);
  friend void swap(AttributeAlarm& a, AttributeAlarm& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline AttributeAlarm* New() const PROTOBUF_FINAL { return New(NULL); }

  AttributeAlarm* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const AttributeAlarm& from);
  void MergeFrom(const AttributeAlarm& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(AttributeAlarm* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // string empty = 1;
  void clear_empty();
  static const int kEmptyFieldNumber = 1;
  const ::std::string& empty() const;
  void set_empty(const ::std::string& value);
  #if LANG_CXX11
  void set_empty(::std::string&& value);
  #endif
  void set_empty(const char* value);
  void set_empty(const char* value, size_t size);
  ::std::string* mutable_empty();
  ::std::string* release_empty();
  void set_allocated_empty(::std::string* empty);

  // @@protoc_insertion_point(class_scope:mascot.AttributeAlarm)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::google::protobuf::internal::ArenaStringPtr empty_;
  mutable int _cached_size_;
  friend struct ::protobuf_attribute_5fconfig_2eproto::TableStruct;
  friend void ::protobuf_attribute_5fconfig_2eproto::InitDefaultsAttributeAlarmImpl();
};
// ===================================================================


// ===================================================================

#ifdef __GNUC__
  #pragma GCC diagnostic push
  #pragma GCC diagnostic ignored "-Wstrict-aliasing"
#endif  // __GNUC__
// AttributeConfig

// string name = 1;
inline void AttributeConfig::clear_name() {
  name_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& AttributeConfig::name() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.name)
  return name_.GetNoArena();
}
inline void AttributeConfig::set_name(const ::std::string& value) {
  
  name_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.name)
}
#if LANG_CXX11
inline void AttributeConfig::set_name(::std::string&& value) {
  
  name_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.AttributeConfig.name)
}
#endif
inline void AttributeConfig::set_name(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  name_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.AttributeConfig.name)
}
inline void AttributeConfig::set_name(const char* value, size_t size) {
  
  name_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.AttributeConfig.name)
}
inline ::std::string* AttributeConfig::mutable_name() {
  
  // @@protoc_insertion_point(field_mutable:mascot.AttributeConfig.name)
  return name_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* AttributeConfig::release_name() {
  // @@protoc_insertion_point(field_release:mascot.AttributeConfig.name)
  
  return name_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void AttributeConfig::set_allocated_name(::std::string* name) {
  if (name != NULL) {
    
  } else {
    
  }
  name_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), name);
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeConfig.name)
}

// .mascot.AttrWriteType writable = 2;
inline void AttributeConfig::clear_writable() {
  writable_ = 0;
}
inline ::mascot::AttrWriteType AttributeConfig::writable() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.writable)
  return static_cast< ::mascot::AttrWriteType >(writable_);
}
inline void AttributeConfig::set_writable(::mascot::AttrWriteType value) {
  
  writable_ = value;
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.writable)
}

// .mascot.AttrDataFormat data_format = 3;
inline void AttributeConfig::clear_data_format() {
  data_format_ = 0;
}
inline ::mascot::AttrDataFormat AttributeConfig::data_format() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.data_format)
  return static_cast< ::mascot::AttrDataFormat >(data_format_);
}
inline void AttributeConfig::set_data_format(::mascot::AttrDataFormat value) {
  
  data_format_ = value;
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.data_format)
}

// int64 data_type = 4;
inline void AttributeConfig::clear_data_type() {
  data_type_ = GOOGLE_LONGLONG(0);
}
inline ::google::protobuf::int64 AttributeConfig::data_type() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.data_type)
  return data_type_;
}
inline void AttributeConfig::set_data_type(::google::protobuf::int64 value) {
  
  data_type_ = value;
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.data_type)
}

// bool memorized = 5;
inline void AttributeConfig::clear_memorized() {
  memorized_ = false;
}
inline bool AttributeConfig::memorized() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.memorized)
  return memorized_;
}
inline void AttributeConfig::set_memorized(bool value) {
  
  memorized_ = value;
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.memorized)
}

// bool mem_init = 6;
inline void AttributeConfig::clear_mem_init() {
  mem_init_ = false;
}
inline bool AttributeConfig::mem_init() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.mem_init)
  return mem_init_;
}
inline void AttributeConfig::set_mem_init(bool value) {
  
  mem_init_ = value;
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.mem_init)
}

// int64 max_dim_x = 7;
inline void AttributeConfig::clear_max_dim_x() {
  max_dim_x_ = GOOGLE_LONGLONG(0);
}
inline ::google::protobuf::int64 AttributeConfig::max_dim_x() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.max_dim_x)
  return max_dim_x_;
}
inline void AttributeConfig::set_max_dim_x(::google::protobuf::int64 value) {
  
  max_dim_x_ = value;
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.max_dim_x)
}

// int64 max_dim_y = 8;
inline void AttributeConfig::clear_max_dim_y() {
  max_dim_y_ = GOOGLE_LONGLONG(0);
}
inline ::google::protobuf::int64 AttributeConfig::max_dim_y() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.max_dim_y)
  return max_dim_y_;
}
inline void AttributeConfig::set_max_dim_y(::google::protobuf::int64 value) {
  
  max_dim_y_ = value;
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.max_dim_y)
}

// string description = 9;
inline void AttributeConfig::clear_description() {
  description_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& AttributeConfig::description() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.description)
  return description_.GetNoArena();
}
inline void AttributeConfig::set_description(const ::std::string& value) {
  
  description_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.description)
}
#if LANG_CXX11
inline void AttributeConfig::set_description(::std::string&& value) {
  
  description_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.AttributeConfig.description)
}
#endif
inline void AttributeConfig::set_description(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  description_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.AttributeConfig.description)
}
inline void AttributeConfig::set_description(const char* value, size_t size) {
  
  description_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.AttributeConfig.description)
}
inline ::std::string* AttributeConfig::mutable_description() {
  
  // @@protoc_insertion_point(field_mutable:mascot.AttributeConfig.description)
  return description_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* AttributeConfig::release_description() {
  // @@protoc_insertion_point(field_release:mascot.AttributeConfig.description)
  
  return description_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void AttributeConfig::set_allocated_description(::std::string* description) {
  if (description != NULL) {
    
  } else {
    
  }
  description_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), description);
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeConfig.description)
}

// string label = 10;
inline void AttributeConfig::clear_label() {
  label_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& AttributeConfig::label() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.label)
  return label_.GetNoArena();
}
inline void AttributeConfig::set_label(const ::std::string& value) {
  
  label_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.label)
}
#if LANG_CXX11
inline void AttributeConfig::set_label(::std::string&& value) {
  
  label_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.AttributeConfig.label)
}
#endif
inline void AttributeConfig::set_label(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  label_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.AttributeConfig.label)
}
inline void AttributeConfig::set_label(const char* value, size_t size) {
  
  label_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.AttributeConfig.label)
}
inline ::std::string* AttributeConfig::mutable_label() {
  
  // @@protoc_insertion_point(field_mutable:mascot.AttributeConfig.label)
  return label_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* AttributeConfig::release_label() {
  // @@protoc_insertion_point(field_release:mascot.AttributeConfig.label)
  
  return label_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void AttributeConfig::set_allocated_label(::std::string* label) {
  if (label != NULL) {
    
  } else {
    
  }
  label_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), label);
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeConfig.label)
}

// string unit = 11;
inline void AttributeConfig::clear_unit() {
  unit_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& AttributeConfig::unit() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.unit)
  return unit_.GetNoArena();
}
inline void AttributeConfig::set_unit(const ::std::string& value) {
  
  unit_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.unit)
}
#if LANG_CXX11
inline void AttributeConfig::set_unit(::std::string&& value) {
  
  unit_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.AttributeConfig.unit)
}
#endif
inline void AttributeConfig::set_unit(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  unit_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.AttributeConfig.unit)
}
inline void AttributeConfig::set_unit(const char* value, size_t size) {
  
  unit_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.AttributeConfig.unit)
}
inline ::std::string* AttributeConfig::mutable_unit() {
  
  // @@protoc_insertion_point(field_mutable:mascot.AttributeConfig.unit)
  return unit_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* AttributeConfig::release_unit() {
  // @@protoc_insertion_point(field_release:mascot.AttributeConfig.unit)
  
  return unit_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void AttributeConfig::set_allocated_unit(::std::string* unit) {
  if (unit != NULL) {
    
  } else {
    
  }
  unit_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), unit);
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeConfig.unit)
}

// string standard_unit = 12;
inline void AttributeConfig::clear_standard_unit() {
  standard_unit_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& AttributeConfig::standard_unit() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.standard_unit)
  return standard_unit_.GetNoArena();
}
inline void AttributeConfig::set_standard_unit(const ::std::string& value) {
  
  standard_unit_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.standard_unit)
}
#if LANG_CXX11
inline void AttributeConfig::set_standard_unit(::std::string&& value) {
  
  standard_unit_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.AttributeConfig.standard_unit)
}
#endif
inline void AttributeConfig::set_standard_unit(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  standard_unit_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.AttributeConfig.standard_unit)
}
inline void AttributeConfig::set_standard_unit(const char* value, size_t size) {
  
  standard_unit_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.AttributeConfig.standard_unit)
}
inline ::std::string* AttributeConfig::mutable_standard_unit() {
  
  // @@protoc_insertion_point(field_mutable:mascot.AttributeConfig.standard_unit)
  return standard_unit_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* AttributeConfig::release_standard_unit() {
  // @@protoc_insertion_point(field_release:mascot.AttributeConfig.standard_unit)
  
  return standard_unit_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void AttributeConfig::set_allocated_standard_unit(::std::string* standard_unit) {
  if (standard_unit != NULL) {
    
  } else {
    
  }
  standard_unit_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), standard_unit);
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeConfig.standard_unit)
}

// string display_unit = 13;
inline void AttributeConfig::clear_display_unit() {
  display_unit_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& AttributeConfig::display_unit() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.display_unit)
  return display_unit_.GetNoArena();
}
inline void AttributeConfig::set_display_unit(const ::std::string& value) {
  
  display_unit_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.display_unit)
}
#if LANG_CXX11
inline void AttributeConfig::set_display_unit(::std::string&& value) {
  
  display_unit_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.AttributeConfig.display_unit)
}
#endif
inline void AttributeConfig::set_display_unit(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  display_unit_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.AttributeConfig.display_unit)
}
inline void AttributeConfig::set_display_unit(const char* value, size_t size) {
  
  display_unit_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.AttributeConfig.display_unit)
}
inline ::std::string* AttributeConfig::mutable_display_unit() {
  
  // @@protoc_insertion_point(field_mutable:mascot.AttributeConfig.display_unit)
  return display_unit_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* AttributeConfig::release_display_unit() {
  // @@protoc_insertion_point(field_release:mascot.AttributeConfig.display_unit)
  
  return display_unit_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void AttributeConfig::set_allocated_display_unit(::std::string* display_unit) {
  if (display_unit != NULL) {
    
  } else {
    
  }
  display_unit_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), display_unit);
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeConfig.display_unit)
}

// string format = 14;
inline void AttributeConfig::clear_format() {
  format_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& AttributeConfig::format() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.format)
  return format_.GetNoArena();
}
inline void AttributeConfig::set_format(const ::std::string& value) {
  
  format_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.format)
}
#if LANG_CXX11
inline void AttributeConfig::set_format(::std::string&& value) {
  
  format_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.AttributeConfig.format)
}
#endif
inline void AttributeConfig::set_format(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  format_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.AttributeConfig.format)
}
inline void AttributeConfig::set_format(const char* value, size_t size) {
  
  format_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.AttributeConfig.format)
}
inline ::std::string* AttributeConfig::mutable_format() {
  
  // @@protoc_insertion_point(field_mutable:mascot.AttributeConfig.format)
  return format_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* AttributeConfig::release_format() {
  // @@protoc_insertion_point(field_release:mascot.AttributeConfig.format)
  
  return format_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void AttributeConfig::set_allocated_format(::std::string* format) {
  if (format != NULL) {
    
  } else {
    
  }
  format_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), format);
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeConfig.format)
}

// string min_value = 15;
inline void AttributeConfig::clear_min_value() {
  min_value_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& AttributeConfig::min_value() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.min_value)
  return min_value_.GetNoArena();
}
inline void AttributeConfig::set_min_value(const ::std::string& value) {
  
  min_value_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.min_value)
}
#if LANG_CXX11
inline void AttributeConfig::set_min_value(::std::string&& value) {
  
  min_value_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.AttributeConfig.min_value)
}
#endif
inline void AttributeConfig::set_min_value(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  min_value_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.AttributeConfig.min_value)
}
inline void AttributeConfig::set_min_value(const char* value, size_t size) {
  
  min_value_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.AttributeConfig.min_value)
}
inline ::std::string* AttributeConfig::mutable_min_value() {
  
  // @@protoc_insertion_point(field_mutable:mascot.AttributeConfig.min_value)
  return min_value_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* AttributeConfig::release_min_value() {
  // @@protoc_insertion_point(field_release:mascot.AttributeConfig.min_value)
  
  return min_value_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void AttributeConfig::set_allocated_min_value(::std::string* min_value) {
  if (min_value != NULL) {
    
  } else {
    
  }
  min_value_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), min_value);
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeConfig.min_value)
}

// string max_value = 16;
inline void AttributeConfig::clear_max_value() {
  max_value_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& AttributeConfig::max_value() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.max_value)
  return max_value_.GetNoArena();
}
inline void AttributeConfig::set_max_value(const ::std::string& value) {
  
  max_value_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.max_value)
}
#if LANG_CXX11
inline void AttributeConfig::set_max_value(::std::string&& value) {
  
  max_value_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.AttributeConfig.max_value)
}
#endif
inline void AttributeConfig::set_max_value(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  max_value_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.AttributeConfig.max_value)
}
inline void AttributeConfig::set_max_value(const char* value, size_t size) {
  
  max_value_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.AttributeConfig.max_value)
}
inline ::std::string* AttributeConfig::mutable_max_value() {
  
  // @@protoc_insertion_point(field_mutable:mascot.AttributeConfig.max_value)
  return max_value_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* AttributeConfig::release_max_value() {
  // @@protoc_insertion_point(field_release:mascot.AttributeConfig.max_value)
  
  return max_value_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void AttributeConfig::set_allocated_max_value(::std::string* max_value) {
  if (max_value != NULL) {
    
  } else {
    
  }
  max_value_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), max_value);
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeConfig.max_value)
}

// string writable_attr_name = 17;
inline void AttributeConfig::clear_writable_attr_name() {
  writable_attr_name_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& AttributeConfig::writable_attr_name() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.writable_attr_name)
  return writable_attr_name_.GetNoArena();
}
inline void AttributeConfig::set_writable_attr_name(const ::std::string& value) {
  
  writable_attr_name_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.writable_attr_name)
}
#if LANG_CXX11
inline void AttributeConfig::set_writable_attr_name(::std::string&& value) {
  
  writable_attr_name_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.AttributeConfig.writable_attr_name)
}
#endif
inline void AttributeConfig::set_writable_attr_name(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  writable_attr_name_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.AttributeConfig.writable_attr_name)
}
inline void AttributeConfig::set_writable_attr_name(const char* value, size_t size) {
  
  writable_attr_name_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.AttributeConfig.writable_attr_name)
}
inline ::std::string* AttributeConfig::mutable_writable_attr_name() {
  
  // @@protoc_insertion_point(field_mutable:mascot.AttributeConfig.writable_attr_name)
  return writable_attr_name_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* AttributeConfig::release_writable_attr_name() {
  // @@protoc_insertion_point(field_release:mascot.AttributeConfig.writable_attr_name)
  
  return writable_attr_name_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void AttributeConfig::set_allocated_writable_attr_name(::std::string* writable_attr_name) {
  if (writable_attr_name != NULL) {
    
  } else {
    
  }
  writable_attr_name_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), writable_attr_name);
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeConfig.writable_attr_name)
}

// .mascot.DispLevel level = 18;
inline void AttributeConfig::clear_level() {
  level_ = 0;
}
inline ::mascot::DispLevel AttributeConfig::level() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.level)
  return static_cast< ::mascot::DispLevel >(level_);
}
inline void AttributeConfig::set_level(::mascot::DispLevel value) {
  
  level_ = value;
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.level)
}

// string root_attr_name = 19;
inline void AttributeConfig::clear_root_attr_name() {
  root_attr_name_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& AttributeConfig::root_attr_name() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.root_attr_name)
  return root_attr_name_.GetNoArena();
}
inline void AttributeConfig::set_root_attr_name(const ::std::string& value) {
  
  root_attr_name_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.root_attr_name)
}
#if LANG_CXX11
inline void AttributeConfig::set_root_attr_name(::std::string&& value) {
  
  root_attr_name_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.AttributeConfig.root_attr_name)
}
#endif
inline void AttributeConfig::set_root_attr_name(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  root_attr_name_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.AttributeConfig.root_attr_name)
}
inline void AttributeConfig::set_root_attr_name(const char* value, size_t size) {
  
  root_attr_name_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.AttributeConfig.root_attr_name)
}
inline ::std::string* AttributeConfig::mutable_root_attr_name() {
  
  // @@protoc_insertion_point(field_mutable:mascot.AttributeConfig.root_attr_name)
  return root_attr_name_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* AttributeConfig::release_root_attr_name() {
  // @@protoc_insertion_point(field_release:mascot.AttributeConfig.root_attr_name)
  
  return root_attr_name_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void AttributeConfig::set_allocated_root_attr_name(::std::string* root_attr_name) {
  if (root_attr_name != NULL) {
    
  } else {
    
  }
  root_attr_name_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), root_attr_name);
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeConfig.root_attr_name)
}

// repeated string enum_labels = 20;
inline int AttributeConfig::enum_labels_size() const {
  return enum_labels_.size();
}
inline void AttributeConfig::clear_enum_labels() {
  enum_labels_.Clear();
}
inline const ::std::string& AttributeConfig::enum_labels(int index) const {
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.enum_labels)
  return enum_labels_.Get(index);
}
inline ::std::string* AttributeConfig::mutable_enum_labels(int index) {
  // @@protoc_insertion_point(field_mutable:mascot.AttributeConfig.enum_labels)
  return enum_labels_.Mutable(index);
}
inline void AttributeConfig::set_enum_labels(int index, const ::std::string& value) {
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.enum_labels)
  enum_labels_.Mutable(index)->assign(value);
}
#if LANG_CXX11
inline void AttributeConfig::set_enum_labels(int index, ::std::string&& value) {
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.enum_labels)
  enum_labels_.Mutable(index)->assign(std::move(value));
}
#endif
inline void AttributeConfig::set_enum_labels(int index, const char* value) {
  GOOGLE_DCHECK(value != NULL);
  enum_labels_.Mutable(index)->assign(value);
  // @@protoc_insertion_point(field_set_char:mascot.AttributeConfig.enum_labels)
}
inline void AttributeConfig::set_enum_labels(int index, const char* value, size_t size) {
  enum_labels_.Mutable(index)->assign(
    reinterpret_cast<const char*>(value), size);
  // @@protoc_insertion_point(field_set_pointer:mascot.AttributeConfig.enum_labels)
}
inline ::std::string* AttributeConfig::add_enum_labels() {
  // @@protoc_insertion_point(field_add_mutable:mascot.AttributeConfig.enum_labels)
  return enum_labels_.Add();
}
inline void AttributeConfig::add_enum_labels(const ::std::string& value) {
  enum_labels_.Add()->assign(value);
  // @@protoc_insertion_point(field_add:mascot.AttributeConfig.enum_labels)
}
#if LANG_CXX11
inline void AttributeConfig::add_enum_labels(::std::string&& value) {
  enum_labels_.Add(std::move(value));
  // @@protoc_insertion_point(field_add:mascot.AttributeConfig.enum_labels)
}
#endif
inline void AttributeConfig::add_enum_labels(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  enum_labels_.Add()->assign(value);
  // @@protoc_insertion_point(field_add_char:mascot.AttributeConfig.enum_labels)
}
inline void AttributeConfig::add_enum_labels(const char* value, size_t size) {
  enum_labels_.Add()->assign(reinterpret_cast<const char*>(value), size);
  // @@protoc_insertion_point(field_add_pointer:mascot.AttributeConfig.enum_labels)
}
inline const ::google::protobuf::RepeatedPtrField< ::std::string>&
AttributeConfig::enum_labels() const {
  // @@protoc_insertion_point(field_list:mascot.AttributeConfig.enum_labels)
  return enum_labels_;
}
inline ::google::protobuf::RepeatedPtrField< ::std::string>*
AttributeConfig::mutable_enum_labels() {
  // @@protoc_insertion_point(field_mutable_list:mascot.AttributeConfig.enum_labels)
  return &enum_labels_;
}

// .mascot.AttributeAlarm att_alarm = 21;
inline bool AttributeConfig::has_att_alarm() const {
  return this != internal_default_instance() && att_alarm_ != NULL;
}
inline void AttributeConfig::clear_att_alarm() {
  if (GetArenaNoVirtual() == NULL && att_alarm_ != NULL) {
    delete att_alarm_;
  }
  att_alarm_ = NULL;
}
inline const ::mascot::AttributeAlarm& AttributeConfig::att_alarm() const {
  const ::mascot::AttributeAlarm* p = att_alarm_;
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.att_alarm)
  return p != NULL ? *p : *reinterpret_cast<const ::mascot::AttributeAlarm*>(
      &::mascot::_AttributeAlarm_default_instance_);
}
inline ::mascot::AttributeAlarm* AttributeConfig::release_att_alarm() {
  // @@protoc_insertion_point(field_release:mascot.AttributeConfig.att_alarm)
  
  ::mascot::AttributeAlarm* temp = att_alarm_;
  att_alarm_ = NULL;
  return temp;
}
inline ::mascot::AttributeAlarm* AttributeConfig::mutable_att_alarm() {
  
  if (att_alarm_ == NULL) {
    att_alarm_ = new ::mascot::AttributeAlarm;
  }
  // @@protoc_insertion_point(field_mutable:mascot.AttributeConfig.att_alarm)
  return att_alarm_;
}
inline void AttributeConfig::set_allocated_att_alarm(::mascot::AttributeAlarm* att_alarm) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  if (message_arena == NULL) {
    delete att_alarm_;
  }
  if (att_alarm) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      att_alarm = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, att_alarm, submessage_arena);
    }
    
  } else {
    
  }
  att_alarm_ = att_alarm;
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeConfig.att_alarm)
}

// .mascot.EventProperties event_prop = 22;
inline bool AttributeConfig::has_event_prop() const {
  return this != internal_default_instance() && event_prop_ != NULL;
}
inline void AttributeConfig::clear_event_prop() {
  if (GetArenaNoVirtual() == NULL && event_prop_ != NULL) {
    delete event_prop_;
  }
  event_prop_ = NULL;
}
inline const ::mascot::EventProperties& AttributeConfig::event_prop() const {
  const ::mascot::EventProperties* p = event_prop_;
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.event_prop)
  return p != NULL ? *p : *reinterpret_cast<const ::mascot::EventProperties*>(
      &::mascot::_EventProperties_default_instance_);
}
inline ::mascot::EventProperties* AttributeConfig::release_event_prop() {
  // @@protoc_insertion_point(field_release:mascot.AttributeConfig.event_prop)
  
  ::mascot::EventProperties* temp = event_prop_;
  event_prop_ = NULL;
  return temp;
}
inline ::mascot::EventProperties* AttributeConfig::mutable_event_prop() {
  
  if (event_prop_ == NULL) {
    event_prop_ = new ::mascot::EventProperties;
  }
  // @@protoc_insertion_point(field_mutable:mascot.AttributeConfig.event_prop)
  return event_prop_;
}
inline void AttributeConfig::set_allocated_event_prop(::mascot::EventProperties* event_prop) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  if (message_arena == NULL) {
    delete event_prop_;
  }
  if (event_prop) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      event_prop = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, event_prop, submessage_arena);
    }
    
  } else {
    
  }
  event_prop_ = event_prop;
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeConfig.event_prop)
}

// repeated string extensions = 23;
inline int AttributeConfig::extensions_size() const {
  return extensions_.size();
}
inline void AttributeConfig::clear_extensions() {
  extensions_.Clear();
}
inline const ::std::string& AttributeConfig::extensions(int index) const {
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.extensions)
  return extensions_.Get(index);
}
inline ::std::string* AttributeConfig::mutable_extensions(int index) {
  // @@protoc_insertion_point(field_mutable:mascot.AttributeConfig.extensions)
  return extensions_.Mutable(index);
}
inline void AttributeConfig::set_extensions(int index, const ::std::string& value) {
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.extensions)
  extensions_.Mutable(index)->assign(value);
}
#if LANG_CXX11
inline void AttributeConfig::set_extensions(int index, ::std::string&& value) {
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.extensions)
  extensions_.Mutable(index)->assign(std::move(value));
}
#endif
inline void AttributeConfig::set_extensions(int index, const char* value) {
  GOOGLE_DCHECK(value != NULL);
  extensions_.Mutable(index)->assign(value);
  // @@protoc_insertion_point(field_set_char:mascot.AttributeConfig.extensions)
}
inline void AttributeConfig::set_extensions(int index, const char* value, size_t size) {
  extensions_.Mutable(index)->assign(
    reinterpret_cast<const char*>(value), size);
  // @@protoc_insertion_point(field_set_pointer:mascot.AttributeConfig.extensions)
}
inline ::std::string* AttributeConfig::add_extensions() {
  // @@protoc_insertion_point(field_add_mutable:mascot.AttributeConfig.extensions)
  return extensions_.Add();
}
inline void AttributeConfig::add_extensions(const ::std::string& value) {
  extensions_.Add()->assign(value);
  // @@protoc_insertion_point(field_add:mascot.AttributeConfig.extensions)
}
#if LANG_CXX11
inline void AttributeConfig::add_extensions(::std::string&& value) {
  extensions_.Add(std::move(value));
  // @@protoc_insertion_point(field_add:mascot.AttributeConfig.extensions)
}
#endif
inline void AttributeConfig::add_extensions(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  extensions_.Add()->assign(value);
  // @@protoc_insertion_point(field_add_char:mascot.AttributeConfig.extensions)
}
inline void AttributeConfig::add_extensions(const char* value, size_t size) {
  extensions_.Add()->assign(reinterpret_cast<const char*>(value), size);
  // @@protoc_insertion_point(field_add_pointer:mascot.AttributeConfig.extensions)
}
inline const ::google::protobuf::RepeatedPtrField< ::std::string>&
AttributeConfig::extensions() const {
  // @@protoc_insertion_point(field_list:mascot.AttributeConfig.extensions)
  return extensions_;
}
inline ::google::protobuf::RepeatedPtrField< ::std::string>*
AttributeConfig::mutable_extensions() {
  // @@protoc_insertion_point(field_mutable_list:mascot.AttributeConfig.extensions)
  return &extensions_;
}

// repeated string sys_extensions = 24;
inline int AttributeConfig::sys_extensions_size() const {
  return sys_extensions_.size();
}
inline void AttributeConfig::clear_sys_extensions() {
  sys_extensions_.Clear();
}
inline const ::std::string& AttributeConfig::sys_extensions(int index) const {
  // @@protoc_insertion_point(field_get:mascot.AttributeConfig.sys_extensions)
  return sys_extensions_.Get(index);
}
inline ::std::string* AttributeConfig::mutable_sys_extensions(int index) {
  // @@protoc_insertion_point(field_mutable:mascot.AttributeConfig.sys_extensions)
  return sys_extensions_.Mutable(index);
}
inline void AttributeConfig::set_sys_extensions(int index, const ::std::string& value) {
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.sys_extensions)
  sys_extensions_.Mutable(index)->assign(value);
}
#if LANG_CXX11
inline void AttributeConfig::set_sys_extensions(int index, ::std::string&& value) {
  // @@protoc_insertion_point(field_set:mascot.AttributeConfig.sys_extensions)
  sys_extensions_.Mutable(index)->assign(std::move(value));
}
#endif
inline void AttributeConfig::set_sys_extensions(int index, const char* value) {
  GOOGLE_DCHECK(value != NULL);
  sys_extensions_.Mutable(index)->assign(value);
  // @@protoc_insertion_point(field_set_char:mascot.AttributeConfig.sys_extensions)
}
inline void AttributeConfig::set_sys_extensions(int index, const char* value, size_t size) {
  sys_extensions_.Mutable(index)->assign(
    reinterpret_cast<const char*>(value), size);
  // @@protoc_insertion_point(field_set_pointer:mascot.AttributeConfig.sys_extensions)
}
inline ::std::string* AttributeConfig::add_sys_extensions() {
  // @@protoc_insertion_point(field_add_mutable:mascot.AttributeConfig.sys_extensions)
  return sys_extensions_.Add();
}
inline void AttributeConfig::add_sys_extensions(const ::std::string& value) {
  sys_extensions_.Add()->assign(value);
  // @@protoc_insertion_point(field_add:mascot.AttributeConfig.sys_extensions)
}
#if LANG_CXX11
inline void AttributeConfig::add_sys_extensions(::std::string&& value) {
  sys_extensions_.Add(std::move(value));
  // @@protoc_insertion_point(field_add:mascot.AttributeConfig.sys_extensions)
}
#endif
inline void AttributeConfig::add_sys_extensions(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  sys_extensions_.Add()->assign(value);
  // @@protoc_insertion_point(field_add_char:mascot.AttributeConfig.sys_extensions)
}
inline void AttributeConfig::add_sys_extensions(const char* value, size_t size) {
  sys_extensions_.Add()->assign(reinterpret_cast<const char*>(value), size);
  // @@protoc_insertion_point(field_add_pointer:mascot.AttributeConfig.sys_extensions)
}
inline const ::google::protobuf::RepeatedPtrField< ::std::string>&
AttributeConfig::sys_extensions() const {
  // @@protoc_insertion_point(field_list:mascot.AttributeConfig.sys_extensions)
  return sys_extensions_;
}
inline ::google::protobuf::RepeatedPtrField< ::std::string>*
AttributeConfig::mutable_sys_extensions() {
  // @@protoc_insertion_point(field_mutable_list:mascot.AttributeConfig.sys_extensions)
  return &sys_extensions_;
}

// -------------------------------------------------------------------

// AttributeConfigReply

// bool success = 1;
inline void AttributeConfigReply::clear_success() {
  success_ = false;
}
inline bool AttributeConfigReply::success() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeConfigReply.success)
  return success_;
}
inline void AttributeConfigReply::set_success(bool value) {
  
  success_ = value;
  // @@protoc_insertion_point(field_set:mascot.AttributeConfigReply.success)
}

// .mascot.Error error = 2;
inline bool AttributeConfigReply::has_error() const {
  return this != internal_default_instance() && error_ != NULL;
}
inline const ::mascot::Error& AttributeConfigReply::error() const {
  const ::mascot::Error* p = error_;
  // @@protoc_insertion_point(field_get:mascot.AttributeConfigReply.error)
  return p != NULL ? *p : *reinterpret_cast<const ::mascot::Error*>(
      &::mascot::_Error_default_instance_);
}
inline ::mascot::Error* AttributeConfigReply::release_error() {
  // @@protoc_insertion_point(field_release:mascot.AttributeConfigReply.error)
  
  ::mascot::Error* temp = error_;
  error_ = NULL;
  return temp;
}
inline ::mascot::Error* AttributeConfigReply::mutable_error() {
  
  if (error_ == NULL) {
    error_ = new ::mascot::Error;
  }
  // @@protoc_insertion_point(field_mutable:mascot.AttributeConfigReply.error)
  return error_;
}
inline void AttributeConfigReply::set_allocated_error(::mascot::Error* error) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  if (message_arena == NULL) {
    delete reinterpret_cast< ::google::protobuf::MessageLite*>(error_);
  }
  if (error) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      error = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, error, submessage_arena);
    }
    
  } else {
    
  }
  error_ = error;
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeConfigReply.error)
}

// .mascot.AttributeConfig data = 3;
inline bool AttributeConfigReply::has_data() const {
  return this != internal_default_instance() && data_ != NULL;
}
inline void AttributeConfigReply::clear_data() {
  if (GetArenaNoVirtual() == NULL && data_ != NULL) {
    delete data_;
  }
  data_ = NULL;
}
inline const ::mascot::AttributeConfig& AttributeConfigReply::data() const {
  const ::mascot::AttributeConfig* p = data_;
  // @@protoc_insertion_point(field_get:mascot.AttributeConfigReply.data)
  return p != NULL ? *p : *reinterpret_cast<const ::mascot::AttributeConfig*>(
      &::mascot::_AttributeConfig_default_instance_);
}
inline ::mascot::AttributeConfig* AttributeConfigReply::release_data() {
  // @@protoc_insertion_point(field_release:mascot.AttributeConfigReply.data)
  
  ::mascot::AttributeConfig* temp = data_;
  data_ = NULL;
  return temp;
}
inline ::mascot::AttributeConfig* AttributeConfigReply::mutable_data() {
  
  if (data_ == NULL) {
    data_ = new ::mascot::AttributeConfig;
  }
  // @@protoc_insertion_point(field_mutable:mascot.AttributeConfigReply.data)
  return data_;
}
inline void AttributeConfigReply::set_allocated_data(::mascot::AttributeConfig* data) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  if (message_arena == NULL) {
    delete data_;
  }
  if (data) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      data = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, data, submessage_arena);
    }
    
  } else {
    
  }
  data_ = data;
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeConfigReply.data)
}

// -------------------------------------------------------------------

// EventProperties

// string empty = 1;
inline void EventProperties::clear_empty() {
  empty_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& EventProperties::empty() const {
  // @@protoc_insertion_point(field_get:mascot.EventProperties.empty)
  return empty_.GetNoArena();
}
inline void EventProperties::set_empty(const ::std::string& value) {
  
  empty_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.EventProperties.empty)
}
#if LANG_CXX11
inline void EventProperties::set_empty(::std::string&& value) {
  
  empty_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.EventProperties.empty)
}
#endif
inline void EventProperties::set_empty(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  empty_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.EventProperties.empty)
}
inline void EventProperties::set_empty(const char* value, size_t size) {
  
  empty_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.EventProperties.empty)
}
inline ::std::string* EventProperties::mutable_empty() {
  
  // @@protoc_insertion_point(field_mutable:mascot.EventProperties.empty)
  return empty_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* EventProperties::release_empty() {
  // @@protoc_insertion_point(field_release:mascot.EventProperties.empty)
  
  return empty_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void EventProperties::set_allocated_empty(::std::string* empty) {
  if (empty != NULL) {
    
  } else {
    
  }
  empty_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), empty);
  // @@protoc_insertion_point(field_set_allocated:mascot.EventProperties.empty)
}

// -------------------------------------------------------------------

// AttributeAlarm

// string empty = 1;
inline void AttributeAlarm::clear_empty() {
  empty_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& AttributeAlarm::empty() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeAlarm.empty)
  return empty_.GetNoArena();
}
inline void AttributeAlarm::set_empty(const ::std::string& value) {
  
  empty_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.AttributeAlarm.empty)
}
#if LANG_CXX11
inline void AttributeAlarm::set_empty(::std::string&& value) {
  
  empty_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.AttributeAlarm.empty)
}
#endif
inline void AttributeAlarm::set_empty(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  empty_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.AttributeAlarm.empty)
}
inline void AttributeAlarm::set_empty(const char* value, size_t size) {
  
  empty_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.AttributeAlarm.empty)
}
inline ::std::string* AttributeAlarm::mutable_empty() {
  
  // @@protoc_insertion_point(field_mutable:mascot.AttributeAlarm.empty)
  return empty_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* AttributeAlarm::release_empty() {
  // @@protoc_insertion_point(field_release:mascot.AttributeAlarm.empty)
  
  return empty_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void AttributeAlarm::set_allocated_empty(::std::string* empty) {
  if (empty != NULL) {
    
  } else {
    
  }
  empty_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), empty);
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeAlarm.empty)
}

#ifdef __GNUC__
  #pragma GCC diagnostic pop
#endif  // __GNUC__
// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------


// @@protoc_insertion_point(namespace_scope)

}  // namespace mascot

// @@protoc_insertion_point(global_scope)

#endif  // PROTOBUF_attribute_5fconfig_2eproto__INCLUDED
